#include <string.h>
#include "bmsfel_p.h"

//################################################
// wb_̃nbV̗vf

//////////////////////////////////////////////////
// RXgN^Q
// key͕K{ key̓e̓Rs[ĎOŗ̈mۂ
BmsHeaderOne::BmsHeaderOne( const char *key ) {
  this->set_key( key );
  this->set_value_first( "" );
  this->next = NULL_HEADER_ONE;
}

// value̓e̓Rs[ĎOŗ̈mۂ
BmsHeaderOne::BmsHeaderOne( const char *key, const char *value ) {
  this->set_key( key );
  this->set_value_first( value );
  this->next = NULL_HEADER_ONE;
}

void BmsHeaderOne::set_key( const char *key ) {
  if ( key == NULL ) { key = ""; }

  this->key = BmsUtil::str_new_cpy( key, true );
  BmsUtil::str2upper( this->key );
}

void BmsHeaderOne::set_value_first( const char *value ) {
  if ( value == NULL ) { value = ""; }

  this->value = BmsUtil::str_new_cpy( value, false );
}

// fXgN^
BmsHeaderOne::~BmsHeaderOne() {
  delete [] this->key;
  delete [] this->value;
}

//////////////////////////////////////////////////
// ẽIuWFĕԂ delete͌Ăяo
BmsHeaderOne *BmsHeaderOne::clone() const {
  return new BmsHeaderOne( this->key, this->value );
}

//////////////////////////////////////////////////
// getn
const char *BmsHeaderOne::get_key() const {
  return this->key;
}

const char *BmsHeaderOne::get_value() const {
  return this->value;
}

// setn
// value̓e̓Rs[ĎOŗ̈mۂ ܂ł̕͏
void BmsHeaderOne::set_value( const char *value ) {
  delete [] this->value;
  set_value_first( value );
}

// Xgn
BmsHeaderOne *BmsHeaderOne::get_next() const {
  return this->next;
}

void BmsHeaderOne::set_next( BmsHeaderOne *next ) {
  this->next = next;
}


//################################################
// wb_̃nbV

// ̃nbVlvZ
unsigned int BmsHeaderHash::hash( const char *str ) const {

  unsigned int h;
  unsigned int position;

  h = 0;
  for ( position = 0; str[position] != '\0'; ++position ) {
    h = h * BmsHeaderHash::MULTIPLIER + (unsigned char)(str[position]);
  }
  return h % BmsHeaderHash::TABLE_SIZE;
}

// ŌĂԌp֐
void BmsHeaderHash::lookup( unsigned int hash_code, BmsHeaderOne *key, BmsHeaderOne **target ) const {
  BmsHeaderOne *prev;
  this->lookup( hash_code, key, target, &prev );
}
void BmsHeaderHash::lookup( unsigned int hash_code, BmsHeaderOne *key, BmsHeaderOne **target, BmsHeaderOne **prev ) const {
  *(prev) = NULL_HEADER_ONE;
  for ( *(target) = table[hash_code]; *(target) != NULL_HEADER_ONE; *(target) = (*(target))->get_next() ) {
    if ( strcmp( (*(target))->get_key(), key->get_key() ) == 0 ) { break; }
    *(prev) = *(target);
  }
}

//////////////////////////////////////////////////
// RXgN^Q
BmsHeaderHash::BmsHeaderHash() {
  for ( int i = 0; i < BmsHeaderHash::TABLE_SIZE; ++i ) {
    this->table[i] = NULL_HEADER_ONE;
  }
  this->count = 0;
}

// fXgN^
BmsHeaderHash::~BmsHeaderHash() {
  this->clear();
}


//////////////////////////////////////////////////
// ẽIuWFĕԂ delete͌Ăяo
BmsHeaderHash *BmsHeaderHash::clone() const {
  BmsHeaderHash *copy = new BmsHeaderHash();
  for ( int i = 0; i < BmsHeaderHash::TABLE_SIZE; ++i ) {
    for ( BmsHeaderOne *temp_one = this->table[i]; temp_one != NULL_HEADER_ONE; temp_one = temp_one->get_next() ) {
      copy->store( temp_one->clone() );
    }
  }
  return copy;
}


//////////////////////////////////////////////////
// getn
int BmsHeaderHash::get_count() const {
  return this->count;
}

//////////////////////////////////////////////////
// vfi[
// keyvaluë̗̓Rs[ĎOŗ̈mۂ ߂l͏㏑ǂ
bool BmsHeaderHash::store( const char *key, const char *value ) {
  return this->store( new BmsHeaderOne( key, value ) );
}
// delete̓Rei (:fetch_oneŎ擾̂nĂ͑ʖ)
bool BmsHeaderHash::store( BmsHeaderOne *one ) {
  bool return_value = false;
  BmsHeaderOne *prev   = NULL_HEADER_ONE;
  BmsHeaderOne *target = NULL_HEADER_ONE;

  this->delete_by_key( one->get_key() );

  unsigned int hash_value = this->hash( one->get_key() );
  lookup( hash_value, one, &target, &prev );

  if ( prev == NULL_HEADER_ONE ) { table[hash_value] = one; }
  else                           { prev->set_next( one ); }

  if ( target == NULL_HEADER_ONE ) { one->set_next( NULL_HEADER_ONE ); }
  else                             { one->set_next( target->get_next() ); }

  if ( target != NULL_HEADER_ONE ) {
    delete target;
    return_value = true;
  }
  else {
    ++this->count;
  }
  return return_value;
}

//////////////////////////////////////////////////
// vfQƂ
// vfL邩ǂ
bool BmsHeaderHash::is_exist( const char *key ) const {
  if ( this->fetch_one( key ) == NULL_HEADER_ONE ) { return false; }
  return true;
}
// vfǂ
bool BmsHeaderHash::is_empty( const char *key ) const {
  return !(this->is_exist( key ));
}

// keyƊ֘AÂĂ镶Ԃ ΋󕶎("")Ԃ
const char *BmsHeaderHash::fetch_str( const char *key ) const {
  BmsHeaderOne *one = this->fetch_one( key );
  if ( one == NULL_HEADER_ONE ) { return ""; }
  else                          { return one->get_value(); }
}
const char *BmsHeaderHash::operator []( const char *key ) const {
  return this->fetch_str( key );
}

// vfIuWFԂ delete͈ڂȂ NULL_HEADER_ONEԂ
BmsHeaderOne *BmsHeaderHash::fetch_one( const char *key ) const {
  BmsHeaderOne one( key ); // 啶̈
  BmsHeaderOne *target;
  lookup( this->hash( one.get_key() ), &one, &target );
  return target;
}

//////////////////////////////////////////////////
// vfHash폜

// keyƈvvfnbV菜
// keyɊ֘AtĂ镶*valuë̗(\ȗ̈悪Kv)ɏ
bool BmsHeaderHash::take_str( const char *key, char *value ) {
  BmsHeaderOne *one = this->take_one( key );
  if ( one == NULL_HEADER_ONE ) { return false; }
  else {
    strcpy( value, one->get_value() );
    delete one;
    return true;
  }
}
// Ɠ炪mۂ̈Ԃ̂deleteKv
char *BmsHeaderHash::take_str( const char *key ) {
  return BmsUtil::str_new_cpy( (this->take_one( key ))->get_value(), false );
}

// keyƊ֘AtĂvfnbV菜
// ̗vfIuWFԂ delete͌Ăяo
BmsHeaderOne *BmsHeaderHash::take_one( const char *key ) {
  BmsHeaderOne one( key ); // 啶̈
  BmsHeaderOne *prev   = NULL_HEADER_ONE;
  BmsHeaderOne *target = NULL_HEADER_ONE;

  unsigned int hash_value = this->hash( one.get_key() );

  lookup( hash_value, &one, &target, &prev );

  if ( target != NULL_HEADER_ONE ) {
    if ( prev == NULL_HEADER_ONE ) { table[hash_value] = target->get_next(); }
    else                           { prev->set_next( target->get_next() ); }

    target->set_next( NULL_HEADER_ONE );
    --this->count;
  }
  return target;
}

// keyƈvvf폜trueԂ ݂ȂꍇfalseԂ
bool BmsHeaderHash::delete_by_key( const char *key ) {
  BmsHeaderOne *one = this->take_one( key );
  if ( one == NULL_HEADER_ONE ) { return false; }
  else {
    delete one;
    return true;
  }
}

// vfЂƂ菜Ԃ delete͌Ăяo
BmsHeaderOne *BmsHeaderHash::shift() {
  for ( int i = 0; i < BmsHeaderHash::TABLE_SIZE; ++i ) {
    if ( this->table[i] != NULL_HEADER_ONE ) {
      BmsHeaderOne *one = this->table[i];
      this->table[i] = one->get_next();
      one->set_next( NULL_HEADER_ONE );
      --this->count;
      return one;
    }
  }
  return NULL_HEADER_ONE;
}

// *key*valuë̗(\ȗ̈悪Kv)ɏ vfꍇfalseԂ
bool BmsHeaderHash::shift( char *key, char *value ) {
  BmsHeaderOne *one = this->shift();
  if ( one != NULL_HEADER_ONE ) {
    strcpy( key,   one->get_key() );
    strcpy( value, one->get_value() );
    delete one;
    return true;
  }
  return false;
}

//////////////////////////////////////////////////
// gɂ ߂l͏
int BmsHeaderHash::clear() {
  int deleted_num = 0;
  for ( int i = 0; i < BmsHeaderHash::TABLE_SIZE; ++i ) {
    if ( this->table[i] != NULL_HEADER_ONE ) {
      BmsHeaderOne *next;
      for ( BmsHeaderOne *temp = this->table[i]; temp != NULL_HEADER_ONE; temp = next ) {
        next = temp->get_next();
        delete temp;
        ++deleted_num;
      }
      this->table[i] = NULL_HEADER_ONE;
    }
  }
  this->count = 0;
  return deleted_num;
}
